'''
- annotation_conf.py
- This file handles the global configuration for the annotation functions used in VIDS
'''


# NER model locations
# DIALOGFLOW_LOC = "models/dialogflow/entitypy-hclqpr-fda9848cedf9.json"
BERT_LOC = "models/student_perf/bert/bert"
ROBERTA_LOC = "models/student_perf/roberta/roberta"
XLNET_LOC = "models/ner/flight_delay/xlnet/xlnet"
DISTILBERT_LOC = "models/student_perf/distilbert/distilbert"
ALBERT_LOC = "models/student_perf/albert/albert"
# BERT_LOC = "models/combined/bert/bert"
# ROBERTA_LOC = "models/combined/roberta/roberta"
# XLNET_LOC = "models/combined/xlnet/xlnet"
# DISTILBERT_LOC = "models/combined/distilbert/distilbert"
# ALBERT_LOC = "models/combined/albert/albert"

# SQUAD model locations
BERT_LOC_SQUAD = "models/squad/student_perf/bert"
XLNET_LOC_SQUAD = "models/squad/student_perf/xlnet"
ROBERTA_LOC_SQUAD = "models/squad/student_perf/roberta"
ALBERT_LOC_SQUAD = "models/squad/student_perf/albert"
DISTILBERT_LOC_SQUAD = "models/squad/student_perf/distilbert"


# Dialogflow configuration
DIALOGFLOW_PROJECT_ID = "entitypy-hclqpr"
DIALOGFLOW_SESSION_ID = "123456789"
DIALOGFLOW_LANGUAGE_CODE = "en-US"


# Stop words
STOP_WORDS = [
    "i", "me", "my", "myself", "we", "our", "ours", "ourselves", "you", "your", "yours", "yourself",
    "yourselves", "he", "him", "his", "himself", "she", "her", "hers", "herself", "it", "its", "itself",
    "they", "them", "their", "theirs", "themselves", "what", "which", "who", "whom", "this", "that",
    "these", "those", "am", "is", "are", "was", "were", "be", "been", "being", "have", "has", "had",
    "having", "do", "does", "did", "doing", "a", "an", "the", "and", "but", "if", "or", "because", "as",
    "until", "while", "of", "at", "by", "for", "with", "about", "against", "between", "into", "through",
    "during", "before", "after", "above", "below", "to", "from", "up", "down", "in", "out", "on", "off",
    "over", "under", "again", "further", "then", "once", "here", "there", "when", "where", "why", "how",
    "all", "any", "both", "each", "few", "more", "most", "other", "some", "such", "no", "nor", "not", "only",
    "own", "same", "so", "than", "too", "very", "s", "t", "can", "will", "just", "don", "should", "now"
]